
export const GET="GET";
export const POST="POST";
export const PUT="PUT";
export const DELETE="DELETE";
export const RESPONCE_TYPE={
    TEXT:"text",
    JSON:"json",
    XML:"xml"
}
export class HttpUtil{
        static fetchData(path:string,method:string,responceType:string,body:any=null){
             let url="";
             let option:any={
                 method:method,
                 headers:{
                     "content-type":"application/json; charset=utf-8"
                   }
                }
               url=path;
               if(body)
                 option["body"]=JSON.stringify(body);
             return new Promise((resolve,reject)=>{
                 fetch(url,option)
                 .then((res)=>{
                    if(responceType==RESPONCE_TYPE.TEXT)
                     return res.text()
                    else
                      return res.json();
                })
                 .then((result)=>{
                     resolve(result);
                 })
                 .catch((err)=>{
                     reject(err)
                 })
             })
         }


       static  post(path:string,body:any,responceType=RESPONCE_TYPE.JSON){
            return this.fetchData(path,POST,responceType,body);
         }
       static put(path:string,body:any,responceType=RESPONCE_TYPE.JSON){
            return this.fetchData(path,PUT,responceType,body);
         }
       static get(path:string,responceType=RESPONCE_TYPE.JSON){
            return this.fetchData(path,GET,responceType);
         }
       static delete(path:string,body:any,responceType=RESPONCE_TYPE.JSON){
            return this.fetchData(path,DELETE,responceType,body);
         }

         static fetchDataFullUrl(path:string,method:string,body:any=null){
            let url="";
            let option:any={
                method:method,
                mode:"no-cors",
                headers:{
                    "content-type":"application/json; charset=utf-8",
                    "Access-Control-Allow-Origin":"*",
                    "Access-Control-Request-Method":"GET",
                    "Access-Control-Request-Headers":"content-type"
                  }
               }
              url=path;
              if(body)
                option["body"]=JSON.stringify(body);
            return new Promise((resolve,reject)=>{
                fetch(url,option)
                .then((res)=>res.text())
                .then((result)=>{
                    resolve(result);
                })
                .catch((err)=>{
                    reject(err)
                })
            })
        }
}